REM DEMONSTRATION PROGRAM FOR
REM CBASIC GRAPHICS EXTENSIONS
REM
REM Martin Hepperle, 2020
REM

%INCLUDE GRAPHCOM.BAS

DIM MX(10),MY(10)

REM Test Drivers 1, 2
FOR G = 1 TO 2
 PRINT "Testing driver ";G

 GRAPHIC OPEN G

 ASK DEVICE X.DIM,Y.DIM
 PRINT "Aspect ratio is ";X.DIM;" x ";Y.DIM

 SET BOUNDS Y.DIM,X.DIM

 SET BEAM "ON"

 REM outer frame
 PLOT (0,1),(1,1),(1,0),(0,0)

 SET CHARACTER HEIGHT 0.02
 GRAPHIC PRINT AT (0.05,0.95): "GSX Driver Test"

 SET CHARACTER HEIGHT 0.05
 GRAPHIC PRINT AT (0.05,0.85): "5 %"
 PLOT (0,0.85),(1,0.85)
 PLOT (0,0.90),(1,0.90)

 SET CHARACTER HEIGHT 0.1
 GRAPHIC PRINT AT (0.05,0.5): "10 %"
 PLOT (0,0.5),(1,0.5)
 PLOT (0,0.6),(1,0.6)

 MX(0)=0.25 : MY(0)=0.15
 MX(1)=0.50 : MY(1)=0.45
 MX(2)=0.75 : MY(2)=0.35

 SET CHARACTER HEIGHT 0.025
 SET JUSTIFY 0.0,0.5

 FOR T=1 TO 6
  SET LINE STYLE T
  MAT PLOT 2: MX, MY

  SET MARKER HEIGHT 0.03
  SET MARKER TYPE T
  SET LINE STYLE 1
  MAT MARKER 2: MX,MY
  SET JUSTIFY 0.0,0.5
  GRAPHIC PRINT AT (0.8,MY(2)): STR$(T)

  SET JUSTIFY 1.0,0.5
  SET TEXT ANGLE 51.5/57.5
  GRAPHIC PRINT AT (0.2,MY(0)): STR$(T)
  SET TEXT ANGLE 0

  MY(0) = MY(0)+0.1
  MY(1) = MY(1)+0.1
  MY(2) = MY(2)+0.1

 NEXT T

 PRINT "Done."

 REM Flush buffer and close metafile
 GRAPHIC CLOSE

NEXT G

END
