C
C     GSX-80 DRIVER for Epson PX-8
C     Copyright (C) 2014 by Udo Munk
C     Copyright (C) 2020 by Martin Hepperle
C
C234567890123456789012345678901234567890123456789012345678901234567890123456789
C----vv----------------------------------------------------------------v-------
      SUBROUTINE DDPX8(CONTRL,INTIN,PTSIN,INTOUT,PTSOUT)
      INTEGER CONTRL(1),INTIN(1),PTSIN(1),INTOUT(1),PTSOUT(1)
C
C     VARIABLES
C
      INTEGER I,J,K
      INTEGER OPCODE,INMODE
      LOGICAL PFLAG,OFLAG
      INTEGER LNTP,MKTP
      INTEGER MSIZE
      INTEGER XY(2)
      INTEGER XLO,YLO,XHI,YHI
C
C     FUNCTIONS
C
      EXTERNAL CLAMP
      INTEGER  CLAMP
C
C     DATA
C
C     FONT SIZES 5x7, 8 multiples
C     CELL SIZES 7x10, 8 multiples
C     PRINT FLAG FOR DRIVER COPYRIGHT AND VERSION TEXT
      DATA PFLAG /.FALSE./
C     WORKSTATION OPEN FLAG
      DATA OFLAG /.FALSE./
C     MARKER SIZE 6 and up
      DATA MSIZE/6/
C
C     INITIALIZATION
C
      CONTRL(3) = 0
      CONTRL(5) = 0
      OPCODE = CONTRL(1)

C     DONT DRAW ON CLOSED WOKSTATION
      IF (OFLAG .NE. .TRUE. .AND. OPCODE .NE. 1) RETURN

C
C     DISPATCH ON OPCODE
C
      GOTO(1100,1200,1300,1400,1500,1600,1700,1800,1900,2000,
     1     2100,2200,2300,2400,2500,2600,2700,2800,2900,3000,
     2     3100,3200,3300,3400,3500,3600,3700,3800,3900,4000,
     3     4100,4200,4300),OPCODE
      RETURN

C
C     OPCODE OPEN WORKSTATION
C
1100  IF (PFLAG .NE. .FALSE.) GOTO 1110
      CALL PXPRTV
      PFLAG = .TRUE.
1110  CONTRL(3) = 6
      CONTRL(5) = 45
      LNTP = CLAMP(INTIN(2),1,3)
      MKTP = CLAMP(INTIN(4),1,6)
      INTOUT(1) = 480-1
      INTOUT(2) = 64-1
      INTOUT(3) = 1
      INTOUT(4) = 460
      INTOUT(5) = 460
      INTOUT(6) = 1
      INTOUT(7) = 3
      INTOUT(8) = 1
      INTOUT(9) = 5
      INTOUT(10) = 4
      INTOUT(11) = 1
      INTOUT(12) = 0
      INTOUT(13) = 0
      INTOUT(14) = 2
      INTOUT(15) = 0
      INTOUT(16) = -1
      INTOUT(17) = -1
      INTOUT(18) = -1
      INTOUT(19) = -1
      INTOUT(20) = -1
      INTOUT(21) = -1
      INTOUT(22) = -1
      INTOUT(23) = -1
      INTOUT(24) = -1
      INTOUT(25) = -1
      INTOUT(26) = -1
      INTOUT(27) = -1
      INTOUT(28) = -1
      INTOUT(29) = -1
      INTOUT(30) = -1
      INTOUT(31) = -1
      INTOUT(32) = -1
      INTOUT(33) = -1
      INTOUT(34) = -1
      INTOUT(35) = -1
      INTOUT(36) = 0
      INTOUT(37) = 0
      INTOUT(38) = 0
      INTOUT(39) = 0
      INTOUT(40) = 2
      INTOUT(41) = 0
      INTOUT(42) = 0
      INTOUT(43) = 0
      INTOUT(44) = 1
      INTOUT(45) = 2
      PTSOUT(1) = 0
      PTSOUT(2) = 1*8
      PTSOUT(3) = 0
      PTSOUT(4) = 1*8
      PTSOUT(5) = 1
      PTSOUT(6) = 0
      PTSOUT(7) = 1
      PTSOUT(8) = 0
      PTSOUT(9) = 0
      PTSOUT(10) = 2
      PTSOUT(11) = 0
      PTSOUT(12) = 16
      OFLAG = .TRUE.

C     screen MODE 3
      CALL PXOUT(27)
      CALL PXOUT(208)
      CALL PXOUT(3)
C     cursor OFF
      CALL PXOUT(27)
      CALL PXOUT('2')

C     CLEAR and RETURN
      GOTO 1300

C
C     OPCODE CLOSE WORKSTATION
C
1200  CONTINUE
C     cursor ON
      CALL PXOUT(27)
      CALL PXOUT('3')
      OFLAG = .FALSE.
      RETURN

C
C     OPCODE CLEAR WORKSTATION
C
C     clear current screen
1300  CALL ESC('*',1)
      RETURN

C
C     OPCODE UPDATE WORKSTATION
C
1400  RETURN

C
C     OPCODE ESCAPE
C
1500  OPCODE = CONTRL(6)
C     DISPATCH ON FUNCTION
      GOTO(1501,1502,1503,1504,1505,1506,1507,1508,1509,1510,
     1     1511,1512,1513,1514),OPCODE
      RETURN

C     INQUIRE ADDRESSABLE CHARACTER CELLS
1501  INTOUT(1) = 24
      INTOUT(2) = 80
      RETURN

C     ENTER GRAPHICS MODE
1502  CONTINUE
C     screen MODE 3
      CALL PXOUT(27)
      CALL PXOUT(208)
      CALL PXOUT(3)
C     cursor OFF
      CALL PXOUT(27)
      CALL PXOUT('2')
      RETURN

C     EXIT GRAPHICS MODE
1503  CONTINUE
C     cursor ON
      CALL PXOUT(27)
      CALL PXOUT('3')
      RETURN

C     CURSOR UP     Esc A
1504  CALL PXOUT(30)
      RETURN
C     CURSOR DOWN   Esc B
1505  CALL PXOUT(31)
      RETURN
C     CURSOR RIGHT  Esc C
1506  CALL PXOUT(28)
      RETURN
C     CURSOR LEFT   Esc D
1507  CALL PXOUT(29)
      RETURN
C     HOME CURSOR
1508  CALL PXOUT(11)
      RETURN
C     ERASE TO END OF SCREEN
1509  CALL ESC('Y',1)
      RETURN
C     ERASE TO END OF LINE
1510  CALL ESC('T',1)
      RETURN
C     DIRECT CURSOR ADDRESS
C     Esc = (m+31) (n+31) == row and column
1511  CALL ESC('=',1)
      I = CLAMP(INTIN(1),1,8) + 31
      CALL PXOUT(I)
      I = CLAMP(INTIN(2),1,80) + 31
      CALL PXOUT(I)
      RETURN
C     OUTPUT CURSOR ADDRESSABLE TEXT
1512  CONTINUE
      CALL PXSTR(CONTRL(4),INTIN)
      RETURN
C     REVERSE VIDEO ON
1513  CONTINUE
      RETURN
C     REVERSE VIDEO OFF
1514  CONTINUE
      RETURN

C
C     OPCODE POLYLINE
C
1600  CONTINUE
      J = CONTRL(2)-1
      K = 1
      DO 1601 I=1,J
         CALL LINE(PTSIN(K),  PTSIN(K+1),
     1             PTSIN(K+2),PTSIN(K+3), LNTP)
         K = K + 2
1601  CONTINUE
      RETURN

C
C     7: OPCODE POLYMARKER
C
1700  CONTINUE
      J = 1
      K = CONTRL(2)
      DO 1701 I=1,K
         CALL MPLOT(PTSIN(J),PTSIN(J+1),MKTP,MSIZE,LNTP)
         J = J + 2
1701  CONTINUE
      RETURN

C
C     8: OPCODE TEXT
C
1800  CONTINUE
C     Esc = (m+31) (n+31) == row and column
      CALL ESC('=',1)
C     (64-Y) / 64 * 8   = row
      I = (64-PTSIN(2)) / 8 + 31
      CALL PXOUT(I)
C     X / 480 * 80 = column
      I = PTSIN(1) / 6 + 31
      CALL PXOUT(I)
C     write text
      CALL PXSTR(CONTRL(4),INTIN)
      RETURN

C
C     9: OPCODE FILLED AREA
C
1900  GOTO 1600
C     RETURN

C
C     10: OPCODE CELL ARRAY
C
2000  CONTINUE
C     CALL PXOUT(29)
C     CALL PXOUT(27)
C     CALL PXOUT(96)
      XLO = PTSIN(1)
      XHI = PTSIN(2)
      XHI = PTSIN(3)
      YHI = PTSIN(4)
C     CALL XYPAIR(XLO,YLO)
C     CALL XYPAIR(XHI,YLO)
C     CALL XYPAIR(XHI,YHI)
C      CALL XYPAIR(XLO,YLO)
C      CALL PXOUT(27)
C      CALL PXOUT(LNTP+95)
C      CALL PXOUT(31)
      RETURN

C
C     OPCODE GENERALZED DRAWING PRIMITIVE
C
2100  RETURN

C
C     OPCODE SET CHARACTER HEIGHT
C
2200  I = PTSIN(2)
      J = 8

      CONTRL(3) = 2
      PTSOUT(1) = J*6/8
      PTSOUT(2) = J
      PTSOUT(3) = J*6/8
      PTSOUT(4) = J
      RETURN

C
C     OPCODE SET CHARACTER UP VECTOR
C
2300  J = CLAMP(INTIN(1),0,3600)
      J = 1 + J/900
      INTOUT(1) = (J-1)*900
      CONTRL(5) = 1
      RETURN

C
C     OPCODE SET COLOR REPRESENTATION
C
2400  CONTINUE
      RETURN

C
C     OPCODE SET POLYLINE LINETYPE
C
2500  LNTP = CLAMP(INTIN(1),1,3)
C     USE TABLE
      INTOUT(1) = LNTP
      RETURN

C
C     OPCODE SET POLYLINE WIDTH
C
2600  CONTRL(3) = 1
      PTSOUT(1) = 1
      PTSOUT(2) = 0
      RETURN

C
C     OPCODE SET POLYLINE COLOR INDEX
C
2700  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET POLYMARKER TYPE
C
2800  MKTP = CLAMP(INTIN(1),1,6)
      INTOUT(1) = MKTP
      RETURN

C
C     19: OPCODE SET POLYMARKER SCALE
C
2900  MSIZE = MAX0(2,PTSIN(2))
      CONTRL(3) = 1
      PTSOUT(1) = 0
      PTSOUT(2) = MSIZE
      RETURN

C
C     OPCODE SET POLYMARKER COLOR INDEX
C
3000  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET TEXT FONT
C
3100  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET TEXT COLOR INDEX
C
3200  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET FILL INTERIOR STYLE
C
3300  INTOUT(1) = 0
      RETURN

C
C     OPCODE SET FILL STYLE INDEX
C
3400  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET FILL COLOR INDEX
C
3500  INTOUT(1) = 1
      RETURN

C
C     OPCODE INQUIRE COLOR REPRESENTATION
C
3600  INTOUT(1) = INTIN(1)
      INTOUT(2) = 0
      INTOUT(3) = 0
      INTOUT(4) = 0
      RETURN

C
C     OPCODE INQUIRE CELL ARRAY
C
3700  CONTRL(8) = 0
      CONTRL(9) = 0
      CONTRL(10) = 1
      RETURN

C
C     OPCODE INPUT LOCATOR
C
3800  CONTINUE
      CONTRL(5) = 1
      CONTRL(3) = 1
      PTSOUT(1) = 1
      PTSOUT(2) = 31
C     KEYBOARD TERMINATION
      INTOUT(1) = 'X'
      RETURN

C
C     OPCODE INPUT VALUATOR
C
3900  CONTRL(5) = 0
      RETURN

C
C     OPCODE INPUT CHOICE
C
4000  CONTRL(5) = 0
      RETURN

C
C     OPCODE INPUT STRING
C
4100  RETURN

C
C     OPCODE SET WRITING MODE
C
4200  INTOUT(1) = 2
      RETURN

C
C     OPCODE SET INPUT MODE
C
4300  INMODE = INTIN(2)
      INTOUT(1) = INMODE
      RETURN

      END

      SUBROUTINE LINE(X0,Y0,X1,Y1,LNTP)
      INTEGER X0,Y0,X1,Y1
      INTEGER HI,LO
      CALL PXOUT(27)
      CALL PXOUT(198)
      CALL XYPAIR(X0,Y0)
      CALL XYPAIR(X1,Y1)

      IF ( LNTP .NE. 1 ) GOTO 2
C     pattern: solid
1     HI = 255
      LO = 255
      GOTO 4

2     IF (LNTP .NE. 2 ) GOTO 3
C     pattern: dotted
      HI = 170
      LO = 170
      GOTO 4

3     CONTINUE
C     pattern: dashed
      HI = 15
      LO = 15

4     CONTINUE
      CALL PXOUT(LO)
      CALL PXOUT(HI)

C     function code: 2=ON
      CALL PXOUT(2)
      RETURN
      END

C
C     CONVERT XY COORDINATES AND OUTPUT
C
      SUBROUTINE XYPAIR(XPT,YPT)
C     parameters
      INTEGER XPT,YPT
C     local
      INTEGER Y,H,L

C     horizontal
      H = XPT/256
      L = XPT - 256*H
      CALL PXOUT(H)
      CALL PXOUT(L)

C     vertical
      Y = 63-YPT
      H = Y/256
      L = Y - 256*H
      CALL PXOUT(H)
      CALL PXOUT(L)

      RETURN

      END

C
C     Draw a marker at the location given in [X,Y]
C
      SUBROUTINE MPLOT(X,Y,TYPE,PMSC,LNTP)
      INTEGER X,Y,TYPE,PMSC,LNTP

      INTEGER X1,X2,Y1,Y2
      INTEGER X3,X4,Y3,Y4
      INTEGER RXY1,RXY2

C     bounding box
      X1 = X - PMSC/2
      X2 = X1 + PMSC
      Y1 = Y - PMSC/2
      Y2 = Y1 + PMSC

C     test bounding box
C      IF (MIN0(X1,Y1).LT.0 .OR. MAX0(X2,Y2).GT.32767) RETURN

      IF (X1.LT.0     .OR. Y1.LT.0 .OR.
     1    X2.GT.32767 .OR. Y2.GT.32767) RETURN

C     for 'x' and '*' approx. PMSC*COS(PI/4)
      RXY1 = PMSC/3 + PMSC/50
      X3 = X - RXY1
      X4 = X + RXY1
      Y3 = Y - RXY1
      Y4 = Y + RXY1

      IF (TYPE.EQ.1 .OR. TYPE.EQ.4 .OR. TYPE.EQ.6) GOTO 5040
      IF (TYPE.EQ.3 .OR. TYPE.EQ.5) GOTO 5020
C     TYPE .EQ. 2 or invalid
      GOTO 5035

C     3,5: 'x'
5020  CONTINUE
      CALL LINE(X3,Y3,
     1          X4,Y4, LNTP)
      CALL LINE(X3,Y4,
     1          X4,Y3, LNTP)
5030  IF (TYPE.EQ.3) GOTO 5035
      GOTO 5060

C     2,3: '+'
5035  CONTINUE
      X3 = X1 + PMSC/2
      Y3 = Y1 + PMSC/2
      CALL LINE(X3,Y1,
     1          X3,Y2, LNTP)
      RXY1 = X1 + PMSC/2
      CALL LINE(X1,Y3,
     1          X2,Y3, LNTP)
      GOTO 5060

C     1,4,6: dot = small x
5040  CONTINUE
      X3 = X1 + PMSC/2 - 30
      Y3 = Y1 + PMSC/2 - 30
      X4 = X3 + 60
      Y4 = Y3 + 60
      CALL LINE(X3,Y3,
     1          X4,Y4, LNTP)
      CALL LINE(X3,Y4,
     1          X4,Y3, LNTP)
      IF (TYPE.EQ.1) GOTO 5060
      IF (TYPE.EQ.6) GOTO 5050
C     4: fall through

C     4: square with dot
5045  CONTINUE
      CALL LINE(X1,Y1,
     1          X2,Y1, LNTP)
      CALL LINE(X2,Y1,
     1          X2,Y2, LNTP)
      CALL LINE(X2,YY,
     1          X1,Y2, LNTP)
      CALL LINE(X1,Y2,
     1          X1,Y1, LNTP)
      GOTO 5060

C     6: diamond with dot
5050  CONTINUE
      X3 = X1 + PMSC/2
      Y3 = Y1 + PMSC/2
      CALL LINE(X1,Y3,
     1          X3,Y2, LNTP)
      CALL LINE(X3,Y2,
     1          X2,Y3, LNTP)
      CALL LINE(X2,Y3,
     1          X3,Y1, LNTP)
      CALL LINE(X3,Y1,
     1          X1,Y3, LNTP)

5060  CONTINUE
      RETURN

      END
C
C     OUTPUT Esc, C(1...N)
C
      SUBROUTINE ESC(C,N)
      INTEGER*1 C(80)
      INTEGER N
      CALL PXOUT(27)
      DO 100 I=1,N
      CALL PXOUT(C(I))
100   CONTINUE
      RETURN
      END

C
C     Limit I to the range LO...HI
C
      INTEGER FUNCTION CLAMP ( I, LO, HI )
      INTEGER I,LO,HI

      IF ( I .LT. LO ) GOTO 100
      IF ( I .GT. HI ) GOTO 200

      CLAMP = I
      RETURN

100   CLAMP = LO
      RETURN

200   CLAMP = HI
      RETURN

      END
